'+--------------+-------------------------------+-----------+
'| * Tutorial   |  Lior Zur <zur@inter.net.il>  | 25/5/1997 |
'+--------------+-------------------------------+-----------+
'| Graphic Tutorial Number 2:                               |
'|                                                          |
'|   Saving and Loading Graphic Arrays using BSAVE - BLOAD  |
'|                                                          |
'+----------------------------------------------------------+
'| For more excellent QB tutorials, demos, stuff and goodies|
'| please visit my homepage at:                             |
'|                                                          |
'|    http://www.geocities.com/SiliconValley/Heights/9246   |
'+----------------------------------------------------------+--+
'| !!!!!!!!!!!!!!!!!!!!!!!! IMPORTANT: !!!!!!!!!!!!!!!!!!!!!!! |
'|                                                             |
'| You can publish this file anywhere, as long as you haven't  |
'| made any change in this file. If you use any of this code   |
'| in your own program, please make sure to give me a credit.  |
'| Also: I don't allow to publish this file on a CD without    |
'| my permission.                                              |
'+-------------------------------------------------------------+
'---------------------------------------------------
'               What are we doing?
'---------------------------------------------------
' BSAVE goes to a place in the computer's memory
' (where the variables are) and records it into a file
' on the hard disk. This is useful for us programmers,
' because this way we can save and restore variables,
' or better: arrays. This way you GET an image from the
' screen into array, and then save it as a file. Later,
' you can load it into array in memory as well.
'
'---------------------------------------------------
'                What are the functions?
'---------------------------------------------------
' Main functions:
'
'BSAVE, to save from memory to file:
' BSAVE FileName$, VARPTR(ArrayName(FirstElement)), LengthInBytesOfArray
' Arguments:
'  1: File name
'  2: Place in memory of data to save from.
'  3: length (in bytes) of array (cube is integer, so it's 5002 * 2.
'                                 it starts at 0 and ends at 5001, so it's
'                                 actually 5002, and each integer is 2 bytes.)
'
' BLOAD, to restore from file to memory:
'  BLOAD FileName$, VARPTR(ArrayName(FirstElement))
'  1: File name
'  2: Place in memory of data to load to.
'
'---------------------------------------------------
'                 Why this is problematic?
'---------------------------------------------------
' You should mess with BLOAD only if you're know
' what you're doing (just follow the example in this case)
' because not all the computer's memory belongs to
' your program, and if you'll write to unknown
' places in the memory, you might write over Basic or the
' operation system: BLOAD doesn't check the address it's writing
' into!
' Also: BSAVE don't allow you to add more information from
' yours to the file, and also don't allow you to save more than
' one picture (or array) in a file. If you want the speed only when
' you load, use a simple for-next loop to save the array, but load
' it using FLOAD - a utility of M/K productions to load arrays as
' fast as BLOAD from files.



DEFINT A-Z         'just for speed...
CLS                          'clear screen, and
SCREEN 13                     'what about 256 colors?
RANDOMIZE TIMER                'we want to generate random image to save...
DIM Cube(0 TO 5001) AS INTEGER 'it's 10004 bytes (5002 integers * 2 bytes)


FOR x = 1 TO 100   'generate random image...
 FOR y = 1 TO 100
  d = INT(RND * 60)
  IF d = 1 THEN c = INT(RND * 100)
  PSET (x, y), c
 NEXT y
NEXT x




LOCATE 14, 1: COLOR 15: PRINT "Press any key to save..."
g$ = INPUT$(1)    'never use SLEEP- it sucks!





' Save the drawing in the array Cube.
GET (1, 1)-(100, 100), Cube

DEF SEG = VARSEG(Cube(0))
'This changes the current segment to the segment that contains "Cube",
'so BSAVE will be able to access it.
'When doing this, we always use the first element of the array as argument.
'
'  VARSEG returns the memory's segment of the array "Cube".
'         (the computer's memory is divided into segments of 65K each,
'          that's why VARPTR cannot be bigger than 65,535, because:)
'
'  VARPTR returns the exact place inside the segment of the array.
'
'This way, we access the memory like finding a house in a city:
'we first go to the street of the house, and then
'we check the house's number inside the street and go there.
'that's why we have to use both varseg and varptr - neither the
'house's number or the street's name will help us alone.

'finally, BSAVE records an array from the memory into a file...
BSAVE "LIOR.TMP", VARPTR(Cube(0)), 10004
DEF SEG                 ' Restore default BASIC segment.




CLS 'clear the screen
LOCATE 14, 1: COLOR 15: PRINT "Press any key to load..."
g$ = INPUT$(1)    'never use SLEEP- it sucks!


'load - very similar to save, but you don't need to give the length.

DEF SEG = VARSEG(Cube(0))
BLOAD "LIOR.TMP", VARPTR(Cube(0))
DEF SEG               ' Restore default BASIC segment.

PUT (1, 1), Cube, PSET     'put our saved image!!

