'+--------------+-------------------------------+-----------+
'| * Tutorial   |  Lior Zur <zur@inter.net.il>  | 25/6/1997 |
'+--------------+-------------------------------+-----------+
'| Graphic Tutorial Number 3:                               |
'|                                                          |
'| Saving and Loading the whole screen using BSAVE - BLOAD  |
'|                                                          |
'+----------------------------------------------------------+
'| For more excellent QB tutorials, demos, stuff and goodies|
'| please visit my homepage at:                             |
'|                                                          |
'|    http://www.geocities.com/SiliconValley/Heights/9246   |
'+----------------------------------------------------------+--+
'| !!!!!!!!!!!!!!!!!!!!!!!! IMPORTANT: !!!!!!!!!!!!!!!!!!!!!!! |
'|                                                             |
'| You can publish this file anywhere, as long as you haven't  |
'| made any change in it. If you use any of this code          |
'| in your own program, please make sure to give me credit.    |
'| Also: I don't anyone allow to publish this file on a CD     |
'| without my permission.                                      |
'+-------------------------------------------------------------+




CLS
SCREEN 13       'this method works mostly in screen 13.
RANDOMIZE TIMER 'we want some randomized graphics...


FileName$ = "Lioram.tmp"
'remember this file name, so you'll be able delete it after using
'the demo.

'lets make randomized graphics to save...
FOR i = 1 TO 70
 x = INT(RND * 320)
 y = INT(RND * 200)
 c = INT(RND * 256)
 CIRCLE (x, y), 82, c
NEXT i


'wait for key press...
COLOR 15
LOCATE 1, 1: PRINT "Press any key to save"
g$ = INPUT$(1)  'Never use SLEEP! It sucks!


'save the screen
DEF SEG = &HA000: BSAVE FileName$, 0, 64000: DEF SEG

'-----------------------------------------------------------------------------
'                      *  What are we doing here?  *
'-----------------------------------------------------------------------------
' ** Introduction **
'
' After tutorial number 2, we know the use of BSAVE and BLOAD. In this
' tutorial we'll see nice BSAVE-BLOAD trick to save the whole screen
' without using an array.
'
' ** The big picture **
'
'   The screen's current image is represented by a memory segment.
' Every single pixel on the screen is represented by 1 byte.
' This means that in screen 13, which has a 320*200 image, there are 64000
' bytes.
'
'** How can we use it? **
'
'   The byte contains the pixel's current color, and when we change a pixel's
' color, we actually change that memory byte. The segment's address is &HA000,
' and that's the first command's meaning: default segment is now the screen's
' segment. Next, we're doing a little trick: We don't have to change the
' image on the screen by Qbasic graphical commands like CIRCLE or PSET, we can
' also change the image DIRECTLY into the memory segment, or, take information
' from there, restore it, and then load it again.
'
'** The simplest use of BSAVE-BLOAD **
'
'   And that's what we're doing now: we are BSAVEing the 64000 bytes of the
' screen image into a file, and then loading them again using BLOAD.
' This is the simplest thing to do with that segment, because we don't have
' to understand how exactly the image is made inside the segment. This
' method is very simple, and saves the use of an array and GET - PUT
' commands. Later, when we'll take a look into the structure of that memory
' segment, we'll be able to do more complicated things like changing each
' pixel writing directly using PEEK and POKE.
'-----------------------------------------------------------------------------


'wait for key press...
CLS
COLOR 15
LOCATE 1, 1: PRINT "Press any key to load"
g$ = INPUT$(1)

'loads the screen:
'Go to the computer's screen segement, and load the saved image...

DEF SEG = &HA000: BLOAD FileName$, 0: DEF SEG

